#ifndef _TEMPFILE_H_
#define _TEMPFILE_H_

/*
   *
   * tempfile.h
   *
   * Copyright (c) 2002-2003 Aleksander Augustowski
   *
   * BUG RAPORTS &
   * E-MAIL:          aleksander.augustowski@ins.com.pl
   * URL:             http://www.ins.com.pl/~alex/bcount/bcount.html
   *
   * This software is open source; you can redistribute it and/or modify
   * it under the terms of the GNU General Public License as published by
   * the Free Software Foundation; either version 2 of the License, or
   * (at your option) any later version.
   *
   * This program is distributed WITHOUT ANY WARRANTY; without even the
   * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
   * See the GNU General Public License in the included COPYING file for
   * details.
   *
   *
*/


static int temporary_number = 0;
static char default_prefix[] = "/tmp/tmp-";


/* Generate unique teporary file */
char *generate_temp_file(char prefix[])
{
	char mkstemp_random[] = "XXXXXX";
	static char tempname_buffer[sizeof(prefix) + sizeof(mkstemp_random) + 50];
	int tlength;
	pid_t pid;
	
	/* Get process-id */
	pid = getpid();

	strcpy (tempname_buffer, prefix);
	tlength = strlen (tempname_buffer);
	
	itoa (pid, &tempname_buffer[tlength]);
	
	strcat (tempname_buffer, mkstemp_random);

	/* Change "XXXXXX" for random string generate with mkstemp, 
	    then unlink file which touch mkstemp */
	mkstemp (tempname_buffer);
	unlink (tempname_buffer);

	strcat (tempname_buffer, ".");
	tlength = strlen (tempname_buffer);

	do
	    {
		itoa (temporary_number++, &tempname_buffer[tlength]);
	    }
	while (access (tempname_buffer, F_OK) != -1);
	
	return(tempname_buffer);
}




/* NIN */

#endif /* _TEMPFILE_H_ */

